<?php
// $Horde: horde/config/registry.php.dist,v 1.52.2.9 2001/12/23 02:22:14 rich Exp $

/**
 *            registry.php -- Horde application registry
 * 
 * This configuration file is used by Horde to determine which Horde
 * applications are installed and where, as well as how they interact.
 */

/**
 * Handlers
 * --------
 * The following settings register particular Horde applications as handlers
 * for functionality intended to be common to multiple Horde applications.
 */

/* auth: Handler for user authentication.
 *   Uncomment the auth/login/logout lines if you want to let either
 *   IMP or Gollem handle the authentication for Horde. This avoids the
 *   "double login" while accessing IMP.
 */
// $this->registry['auth']['login'] = 'imp';
// $this->registry['auth']['logout'] = 'imp';

/* mail: Handler for sending mail. */
$this->registry['mail']['compose'] = 'imp';
$this->registry['mail']['composePopup'] = 'imp';

/* contacts: Handler for contacts management. */
$this->registry['contacts']['search'] = 'turba';
$this->registry['contacts']['add'] = 'turba';
$this->registry['contacts']['sources'] = 'turba';
$this->registry['contacts']['fields'] = 'turba';


/**
 * Application registry
 * --------------------
 * The following settings register installed Horde applications.
 * By default, Horde assumes that the application directories live
 * inside the horde directory.
 * 
 * You should be able to simply uncomment the entries for the applications 
 * you have installed. If you have customized your installation, modify the
 * default settings where necessary. Be sure to remember to uncomment the 
 * trailing ");" line!
 */

$this->applications['horde'] = array(
    'fileroot' => dirname(__FILE__) . '/..',
    'webroot' => '/horde',
    'initial_page' => 'login.php',
    'icon' => '/horde/graphics/home.gif',
    'name' => _("Horde"),
    'allow_guests' => true,
    'show' => true,
    'templates' => dirname(__FILE__) . '/../templates',
    'cookie_domain' => $GLOBALS['HTTP_SERVER_VARS']['SERVER_NAME'],
    'cookie_path' => '/horde',
    'server_name' => $GLOBALS['HTTP_SERVER_VARS']['SERVER_NAME'],
    'server_port' => $GLOBALS['HTTP_SERVER_VARS']['SERVER_PORT']
);

// $this->applications['imp'] = array(
//     'fileroot' => dirname(__FILE__) . '/../imp',
//     'webroot' => $this->applications['horde']['webroot'] . '/imp',
//     'icon' => '/horde/imp/graphics/imp.gif',
//     'name' => _("Mail"),
//     'allow_guests' => true,
//     'show' => true
// );

// $this->applications['turba'] = array(
//     'fileroot' => dirname(__FILE__) . '/../turba',
//     'webroot' => $this->applications['horde']['webroot'] . '/turba',
//     'icon' => '/horde/turba/graphics/turba.gif',
//     'name' => _("Addressbook"),
//     'allow_guests' => false,
//     'show' => true
// );

// $this->applications['chora'] = array(
//     'fileroot' => dirname(__FILE__) . '/../chora',
//     'webroot' => $this->applications['horde']['webroot'] . '/chora',
//     'icon' => '/horde/chora/graphics/chora.gif',
//     'name' => _("CVS"),
//     'allow_guests' => true,
//     'show' => false
// );


/** 
 * Service registry
 * ----------------
 * The following entries register services for specific Horde
 * applications. Unless you need to customize your Horde
 * applications, you shouldn't touch this section.
 */

$this->services['imp']['auth']['login'] = array(
    'link' => "%application%/login.php?redirect_url=|url|"
);
$this->services['imp']['auth']['logout'] = array(
    'link' => "%application%/login.php?reason=logout&redirect_url=|url|"
);
$this->services['imp']['mail']['compose'] = array(
    'link' => "javascript:open_compose_win('popup=1&to=|to|&cc=|cc|&bcc=|bcc|&msg=|msg|&subject=|subject||extra|');",
    'includeFile' => '%application%/templates/javascript/open_compose_win.js',
);
$this->services['imp']['mail']['composePopup'] = array(
    'file' => '%application%/lib/api.php',
    'includeFile' => '%application%/templates/javascript/open_compose_win.js',
    'function' => 'impComposePopup',
    'args' => array()
);
$this->services['imp']['horde']['summary'] = array(
    'file' => '%application%/lib/api.php',
    'function' => 'impSummary',
    'args' => array(),
    'type' => 'string'
);

$this->services['turba']['contacts']['search'] = array(
    'file' => '%application%/lib/api.php',
    'function' => 'turbaExpandAddresses',
    'args' => array('addresses', 'addressbooks', 'fields'),
    'type' => 'array'
);
$this->services['turba']['contacts']['add'] = array(
    'file' => '%application%/lib/api.php',
    'function' => 'turbaAddAddress',
    'args' => array('name', 'address', 'addressbook'),
    'type' => 'boolean'
);
$this->services['turba']['contacts']['sources'] = array(
    'file' => '%application%/lib/api.php',
    'function' => 'turbaGetSources',
    'args' => array('writeable'),
    'type' => 'array'
);
$this->services['turba']['contacts']['fields'] = array(
    'file' => '%application%/lib/api.php',
    'function' => 'turbaGetFields',
    'args' => array('addressbook'),
    'type' => 'array'
);

$this->services['default']['mail']['compose'] = array(
    'link' => "mailto:%to%"
);

?>
